/*	v1.2, 6/4/98

	=====
	
	NetStat Client software - for NetStat.Net
	Copyright (C) 1998  Roddy Richards <roddy@richards.org>

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

	=====

	See the included LICENSE file for licensing information, and
	COPYING for copyright information.
 	
	The .h file's #defines should be intuitive, but here is a brief 
	explanation:
	
    PING_LOCATION: the absolute path to the 'ping' binary on your system. 
            Use 'whereis ping' to determine the path to ping if you're unsure.  
    HTML:   the absolute path  to the public_html, pub_html or html 
    		directory on your system where you plan to store the results. 
    NSC:    the absolute path of the nsc directory (uncompressed from the .tar) 
            NSC stands for 'Network Status Client', in case you were wondering. 
	
	Feel free to look over the client code. Keep in mind that we're 
	relying on the data to be presented in the way that the client 
	currently presents it.

	See the included LICENSE file for licensing information
	
	


	1998 Roddy Richards <roddy@richards.org>
*/

/* includes */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/time.h>
#include <time.h>
#include <sys/stat.h>

/* defines */

#define PING_LOCATION       "/sbin/ping"
#define HTML                "/usr2/home/pi/html/"
#define NSC                 "/usr2/home/pi/nsc"	

#define HOST_FILE               NSC     "/hosts.nsc"
#define DATA                    NSC     "/data/"
#define NUM_HOSTS 128           /* MAX number hosts in the list to ping */
#define MAX 256
#define RESULT_NAME "results"
#define PING_TRIES "100"        /* number tries to ping */

/* structs */

typedef struct {  
        char *name;             /* name of host */
        char *dname;            /* display name */
        char *ip;               /* host IP address */
        int status;             /* 0 if everything's ok */
        float min;              /* Minimum time :from ping */
        float avg;              /* Average time :from ping */
        float max;              /* Maximum time :from ping */
        int loss;               /* Packet Loss  :from ping */
        int recv;               /* Packets rcvd :from ping */
} hosttype;

/* prototypes */

FILE *fcheck(char name[], char *mode);

void ReadHosts(hosttype hosts[NUM_HOSTS], int *num);
void PingHosts(hosttype hosts[NUM_HOSTS], int start, int end);

void PingWrite(hosttype *hosts, FILE *fp);
void PingParse(hosttype *hosts);

